//定义一个数组用来保存用户上传文件
let arr=[];
//点击导航栏后定位到相应区域的滚动条数值
let click_scroll_position = 0;
//点击导航栏后定位到相应区域与文档中的index值
let click_see_detail_index = 0;
//入口函数
$(function() {
	//加载评论分页
	loadCommentPage();
	//是否显示产品信息、参数、评论导航栏
	tab_taggle();
	//点击导航栏定位到相应模块
	$(".goods_detail_nav a").on("click",function(){
		if(!$(".goods_detail_nav").hasClass("assurgent")){
			$(".goods_detail_nav").addClass("assurgent");
		}
		const top = $(".detailed_content .tab_title:eq("+$(this).index()+")").offset().top;
		// 85为 顶部导航栏高度49加导航栏35，加1空白
		$(window).scrollTop(Math.trunc(top - 85));
	})

	//分页切换
	$("#evaluation_page1").show();
	let arr_data;
	if($('#data_length').val()!=undefined){
		arr_data=$('#data_length').val().split(",");
	}
	$("#page li").click(function (){
		$("#hint").children("span").remove();
	    let page=$(this).html();
		if(page=="5" && arr_data[0] > arr_data[1] * 5){
			$("#hint").append("<span style='width:100% display:block; color: var(--sub_text); margin-top:10px; text-align: center; '>已爲您隱藏較早的評論！</span>");
		}else{
		    if(page==$("#page li").toArray().length) {
		        $("#hint").append("<span style='display:block; color: var(--sub_text); margin-top:10px; text-align: center; '>已爲您展示所有評論！</span>");
	        }
	    }
	    $(".evaluation_page").hide();
	    $("#evaluation_page"+page).show();
	})
	
	//点击查看大图
	$(".pimg").click(function(){
		//获取当前评论是第几条
		let evaluation_num=$(this).attr("value");
		const new_img_src=$(this).attr("src");
		const old_img_src=$(".innerdiv"+evaluation_num+" img").attr("src");
		const is_show=$(".outerdiv"+evaluation_num).attr("style");
		if(new_img_src==old_img_src && is_show=="" ){
			$(".outerdiv"+evaluation_num).fadeOut("fast");
		}else{
			let _this = $(this);//将当前的pimg元素作为_this传入函数
			img_show("#outerdiv", "#innerdiv", "#bigimg", _this,evaluation_num);
		}
	});
	
	//显示总评分数
	 const num=$("#star_total").val();
	 const width=parseInt(94*num/5);
	        $("#star_bg").css({
	            "width":width+"px",
	            }
	        )
	//点击上传图片
	$("#add_evaluation_img").click(function() {
		$("input[type=file]").click();
	})
	//点击弹出评论框
	$("#add_evaluation_btn").click(function() {
		$("#evaluation_box").css("display", "block");
		$(".index_addBox").show();
	})
	//设置两个状态的星星
	const emptyStar = "☆";
	const fullStar = "★";
	//li鼠标移入事件
	$(".star_evaluation li").mouseenter(function() {
		$(this).text(fullStar).prevAll().text(fullStar).css("color", "var(--option_selected)").end().nextAll().text(emptyStar).css("color", "var(--option_selected)");
		const  star=$(".star_evaluation li").index(this)+1;
		rating(star);
	});
	//li鼠标离开事件
	$(".star_evaluation li").mouseleave(function() {
		$(".star_evaluation li").text(emptyStar);
		$(".star_evaluation li.current").text(fullStar).prevAll().text(fullStar).end().nextAll().text(emptyStar);
		const star = $(".star_evaluation ul>li.current").index() + 1; //获取用户评分
		rating(star);
	});
	//li点击事件
	$(".star_evaluation li").click(function() {
		if ($(this).hasClass("current")) {
			$(this).removeAttr("class");
		} else {
			$(this).attr("class", "current").siblings().removeAttr("class");
		}
		const star = $(".star_evaluation ul>li.current").index() + 1; //获取用户评分
		rating(star);
	})
	//button点击事件，上传评价
	$("#submit").click(function() {
		//判断是否在前面加0
		function getNow(s) {
			return s < 10 ? '0' + s : s;
		}
		let boo = false;
		for (let i = 0; i < $(".star_evaluation ul>li").length; i++) {
			if ($(".star_evaluation ul>li").hasClass("current")) {
				boo = true;
			}
		}
		//用户名非空判断
		let userName = $("#user_name").val();
		//对用户输入进行转义，防止js注入
		userName=$('<span/>').text(userName).html();
		if (userName == "") {
			alert("請填寫您的稱呼！");
			return false;
		} else {
			if (boo) {
				//获取提交时间
				let myDate = new Date();
				let year = myDate.getFullYear(); //获取当前年
				let month = myDate.getMonth() + 1; //获取当前月
				let date = myDate.getDate(); //获取当前日
				let h = myDate.getHours(); //获取当前小时数(0-23)
				let m = myDate.getMinutes(); //获取当前分钟数(0-59)
				let s = myDate.getSeconds(); //获取当前秒数
				let timeDate = year + '-' + getNow(month) + "-" + getNow(date) + " " + getNow(h) + ':' +
					getNow(m) + ":" + getNow(s); //拼接获取数据
				let todayDate=year + '-' + getNow(month) + "-" + getNow(date);
				//获取表单数据
				let star = $(".star_evaluation ul>li.current").index() + 1; //获取用户评分
				let formData = new FormData(document.getElementById("evaluation_form"));
				let evaluationContent = formData.get('user_evaluation');
				//对用户评论进行特殊字符转义，防止js注入
				evaluationContent=$('<span/>').text(evaluationContent).html();
				let evaluationImgs = $("#evaluation_imgs")[0].files;
				//添加数据
				formData.append("username", userName);
				formData.append("star", star);
				formData.append("comment", evaluationContent);
				formData.append("add_time", timeDate);
				formData.append("today", todayDate);
				formData.append("uid", $("#uid").val());
				formData.append("item_sn", $("#item_sn").val());
				// formData.append("goodsName", $("#goods_name").val());
				for (let i = 0; i < arr.length; i++) {
					//获得文件类型
					const fileName=arr[i].name;
					let fileType = arr[i].type;
					if (fileType == "image/jpg" || fileType == "image/gif" || fileType == "image/png" || fileType ==
						"image/webp" || fileType == "image/jpeg" || fileType == "image/bmp") {} else {
						alert(fileName + " :文件格式不正確，請重新選擇並提交！");
						return false;
					}
				}
				for (let i = 0; i < arr.length; i++) {
					formData.append('comment_imgs[]', arr[i]);
				}
				//提交数据
				$.ajax({
					url: '/comment',
					type: "POST",
					data: formData,
					cache: false,
					contentType: false,
					processData: false,
					dataType: 'json',
					success: function(res) {
						//初始化评分
						$(".star_evaluation li").text(fullStar);
						$(".star_evaluation li").removeAttr("class");
						$(".star_evaluation li:eq(4)").addClass("current");
						$("#star_prompt").html("推薦");
						//清空文本框
						$("#user_name").val("");
						$("#user_evaluation").val("")
						//清空数组
						arr=[];
						//清空缩略图
						$("#thumbnail .user_thumbnail_img").remove();
						//隐藏弹出窗口和遮罩层
						$(".anim-down").hide();
						$(".index_addBox").hide();
						if(res.status == 1){
							alert("發表成功！");
						}else{
							alert(res.msg);
						}
					},
					error: function(res) {
						alert(res.responseJSON.message);
					}
				})

			} else {
				alert("您還沒爲我打分呢！");
				return boo;
			}
		}
	})
});
//评价文字评级
function rating(star){
	switch(star){
		case 1 : $("#star_prompt").html("很差");break;
		case 2 : $("#star_prompt").html("差");break;
		case 3 : $("#star_prompt").html("一般");break;
		case 4 : $("#star_prompt").html("滿意");break;
		case 5 : $("#star_prompt").html("推薦");break;
		default: $("#star_prompt").html("");
	}
}

//加载评论分页
function loadCommentPage(){
	//单页显示条数
	let pageCount = 6
	let $pimg = $('.pimg').clone()
	$('.pimg').remove();
	let $evaluation = $('.evaluation').clone()
	$('.evaluation').remove();
	let $page = $('.evaluation_page').clone()
	$('.evaluation_page').remove()
	let $li =  $('#page').find('li').clone()
	$('#page').find('li').remove();
	//6条一页
	commentList.forEach((item,index)=>{
		let group = Math.floor(index/pageCount);
		if(index%pageCount==0){
			let $p = $page.clone()
			$p.attr("id","evaluation_page"+(group+1))
			if(group==0){
				$p.show()
			}else{
				$p.hide()
			}
			$('#reviews').find('.evaluation_top').after($p)
			let $l = $li.clone()
			$l.html(group+1)
			$('#page').append($l)
		}
		let $e = $evaluation.clone()
		$e.find('.name').html(item.userName)
		let star = '';
		for (let i = 0; i < Number(item.star); i++) {
			if (i < 5) {
				star+='★'
			}
		}
		$e.find('.star').html(star)
		let imgs = item.commentImg||''
		if(imgs){
			let arr = imgs.split(',')
			for (let i = 0; i < arr.length; i++) {
				let $img = $pimg.clone()
				$img.attr('src',arr[i])
				$e.find('.evaluation_img').append($img)
			}
		}
		$e.find('.evaluation_date').html(item.commentTime)
		$e.find('.comments').prepend(item.commentContent)
		$('#evaluation_page'+(group+1)).append($e)
	})
}
//用户上传图片及预览
function uploadFiles() {
	let URL = window.URL || window.webkitURL;
	let fileImgs = $("#evaluation_imgs")[0].files;
	// 当用户已经上传5张，当前上传大于5张，上传的加已上传的大于5张时触发
	if (arr.length >= 5 || fileImgs.length > 5 || arr.length+fileImgs.length > 5) {
		alert('您最多只能上傳五張圖片！');
		//清空文件域
		let file = $("#evaluation_imgs");
		file.after(file.clone().val(""));
		file.remove();
		return false;
	}
	for(let i of fileImgs){
		if(arr.find(val=>{return fileImgs[0].name==val.name}) != undefined){
			alert("上傳圖片重複！");
			//清空文件域
			let file = $("#evaluation_imgs");
			file.after(file.clone().val(""));
			file.remove();
			return false;
		}
	}
	if(fileImgs.length != 0 && fileImgs.length+arr.length <= 5){
				for (let i=0;i<fileImgs.length;i++){
					arr[arr.length]=fileImgs[i];
		}
	}
	$("#thumbnail .user_thumbnail_img").remove();
	for (let i = 0; i < arr.length; i++) {
		if(arr[i].size==0){
			arr.splice(i, 1);
		}
		let imgURL = URL.createObjectURL(arr[i]);
		$("#add_evaluation_img").before("<div class='user_thumbnail_img'><img src='" + imgURL + "'/><i class='fa fa-trash-o fa-lg del_img' onclick='del_upload_files("+i+")'></i></span></div>");
	}
	$("#thumbnail").show();
	//清空文件域
	let file = $("#evaluation_imgs");
	file.after(file.clone().val(""));
	file.remove();
}

//删除上传及预览图片
function del_upload_files(index) {
	arr.splice(index, 1);
	$("#thumbnail .user_thumbnail_img").remove();
	for (let i = 0; i < arr.length; i++) {
		let imgURL = URL.createObjectURL(arr[i]);
		$("#add_evaluation_img").before("<div class='user_thumbnail_img'><img src='" + imgURL + "'/><i class='fa fa-trash-o fa-lg del_img'  onclick='del_upload_files("+i+")'></i></div>");
	}
}

//评论字数限制
function text_count(){
	if($("#user_evaluation").val().length<=1500){
		$("#text_count").text($("#user_evaluation").val().length);
	}else{
		const text=$("#user_evaluation").val().substring(0,1500);
		$("#user_evaluation").val(text);
		$("#text_count").text(text.length);
	}
}

function img_show(outerdiv, innerdiv, big_img, _this,evaluation_num){
        let src = _this.attr("src");//获取当前点击的pimg元素中的src属性
        $(big_img+evaluation_num).attr("src", src);//设置#bigimg元素的src属性
        /*获取当前点击图片的真实大小，并显示弹出层及大图*/
            let window_width = $(window).width();//获取当前窗口宽度
            let real_width = this.width;//获取图片真实宽度
            let window_height = $(window).height();//获取当前窗口高度
            let real_height = this.height;//获取图片真实高度
            let img_width, img_height;
            let scale = 0.8;//缩放尺寸，当图片真实宽度和高度大于窗口宽度和高度时进行缩放

            if(real_height>window_height*scale) {//判断图片高度

                img_height = window_height*scale;//如大于窗口高度，图片高度进行缩放
                img_width = img_height/real_height*real_width;//等比例缩放宽度
                if(img_width>window_width*scale) {//如宽度扔大于窗口宽度
                    img_width = window_width*scale;//再对宽度进行缩放
                }
            } else if(real_width>window_width*scale) {//如图片高度合适，判断图片宽度
                img_width = window_width*scale;//如大于窗口宽度，图片宽度进行缩放
                img_height = img_width/real_width*real_height;//等比例缩放高度
            } else {//如果图片真实高度和宽度都符合要求，高宽不变
                img_width = real_width;
                img_height = real_height;
            }
            $(big_img+evaluation_num).css("width",img_width);//以最终的宽度对图片缩放

            let w = (window_width-img_width)/2;//计算图片与窗口左边距
            let h = (window_height-img_height)/2;//计算图片与窗口上边距
            $(".innerdiv"+evaluation_num).css({"top":h, "left":w});//设置#innerdiv的top和left属性
            $(".outerdiv"+evaluation_num).fadeIn("fast");//淡入显示#outerdiv及.pimg


        $(".outerdiv"+evaluation_num).click(function(){//再次点击淡出消失弹出层
            $(this).fadeOut("fast");
        });
    }

function tab_taggle(){
	if($(".tab_title").toArray().length > 1){
		$(".goods_detail_nav").css("display","flex");
	}
	$(window).scroll(function () {
		const tab_height = $(".tab_title").toArray().map(item=>$(item).offset().top - $(window).height() + 150);
		const scroll_position = $(document).scrollTop();
		let index_arr = new Array();
		tab_height.forEach((item,index)=>{
			if(scroll_position > item){
				index_arr[index_arr.length] = index;
			}
		});
		if(index_arr.length > 0){
			// 当点击导航栏查看对应模块后防止页面存在多个模块时，向上滚动后 切换导航栏当前查看模块选中错误
			// 当前滚动条位置、要切换的选中导航栏index值，同时大于或小于之前点击导航栏相应值时
			if( (scroll_position <= click_scroll_position && index_arr[index_arr.length - 1] <= click_see_detail_index ) || (scroll_position >= click_scroll_position && index_arr[index_arr.length - 1] >= click_see_detail_index ) ){
				$(".goods_detail_nav span").removeClass("see_this");
				$(".goods_detail_nav a").eq(index_arr[index_arr.length - 1]).children("span").addClass("see_this");
			}
		}
		//当多个模块同时出现在页面时
		if(index_arr.length > 1){
			let offset_height = $(".layui-tab-content>div:eq("+index_arr[index_arr.length - 2]+")").offset().top;
			//点击锚链接时触发
			// 85 减导航栏35加边距5 为45
			if(Math.trunc(offset_height - 45) === Math.trunc(scroll_position)){
				$(".goods_detail_nav span").removeClass("see_this");
				$(".goods_detail_nav a").eq(index_arr[index_arr.length - 2]).children("span").addClass("see_this");
				click_scroll_position = Math.trunc(scroll_position);
				click_see_detail_index = index_arr[index_arr.length - 2];
			}
		}
		//判断是否悬浮
		if($(".tab_title:first").offset().top < scroll_position + 90){
			$(".goods_detail_nav").addClass("assurgent");
		}else{
			$(".goods_detail_nav").removeClass("assurgent");
		}
	})
}